////////////////////////////////////////////////////////////////////////////////
//
//	Author: Leblanc Christophe < christopheleblanc@gmx.com >
//	
//	-This code is distributed for free without any warrantee.
//      -You can use it and redistribute it without restrictions.
//	
////////////////////////////////////////////////////////////////////////////////

var config = {
    width: 800,
    height: 600,
    type: Phaser.WEBGL,
    backgroundColor: '#000000',
    parent: 'game_screen',
    scene: {
        preload: preload,
        create: create,
        update: update
    }
};

var game = new Phaser.Game(config);

var vfxmgr;
var follower;
var path;
var pos;


function preload(){
    
    this.load.image('blue', 'assets/blue.png');
    this.load.image('red', 'assets/red.png');
    this.load.image('green', 'assets/green.png');
    
}

function create ()
{
    
    vfxmgr = new VisualEffects.Manager(this);
    
    //Use a path and a path follower to play the animation
    follower = { t: 0, vec: new Phaser.Math.Vector2() };
    
    path = new Phaser.Curves.Path();

    path.add(new Phaser.Curves.Ellipse(400, 300, 100));
    
    this.tweens.add({
        targets: follower,
        t: 1,
        ease: 'Sine.easeInOut',
        duration: 4000,
        repeat: -1
    });
    
    pos = new Phaser.Math.Vector2();
    
    var timedEvent = this.time.addEvent({ delay: 1400, callback: function(){
            
        vfxmgr.play(VisualEffects.Fx1, pos.x, pos.y);
            
    }, callbackScope: this, loop: true });

    var timedEvent = this.time.addEvent({ delay: 3300, callback: function(){
            
        vfxmgr.play(VisualEffects.Fx2, pos.x, pos.y);
            
    }, callbackScope: this, loop: true });

    var timedEvent = this.time.addEvent({ delay: 2900, callback: function(){
            
        vfxmgr.play(VisualEffects.Fx3, pos.x, pos.y);
            
    }, callbackScope: this, loop: true });
    
}

function update(time, delta){
    
    path.getPoint(follower.t, follower.vec);
    
    pos.x = follower.vec.x;
    pos.y = follower.vec.y;
    vfxmgr.update(delta);
    
    

}