////////////////////////////////////////////////////////////////////////////////
//
//	Author: Leblanc Christophe < christopheleblanc@gmx.com >
//	
//	-This code is distributed for free without any warrantee.
//      -You can use it and redistribute it without restrictions.
//	
////////////////////////////////////////////////////////////////////////////////

VisualEffects.Manager = function(phaser){
    
    var th_ = this;
    
    this.vfxs = [];
    this.dead;
    
    this.play = function(vfx_o, x, y){
        
        var vfx = vfx_o.create(phaser, x, y);
        
        th_.vfxs.push(vfx);
        
    }
    
    this.update = function(delta){
        
        var length = th_.vfxs.length;
        
        for(var i = 0; i < length; i++){
            
            var vfx = th_.vfxs[i];
            
            if(vfx.life > 0){
                
                vfx.update(delta);
                
            }
            else{
                
                //  Moves the dead particle to the end of the particles array (ready for splicing out later)
                var last = th_.vfxs[length - 1];

                th_.vfxs[length - 1] = vfx;
                th_.vfxs[i] = last;
                
                i -= 1;
                length -= 1;
                
            }
            
        }
        
        //  Move dead particles to the dead array
        var deadLength = th_.vfxs.length - length;
        
        if (deadLength > 0){
            
            var rip = th_.vfxs.splice(th_.vfxs.length - deadLength, deadLength);

            for (var i = 0; i < rip.length; i++){
                
                rip[i].destroy();
                
                
            }

            
        }
        
    }
    
}
